xquery version "3.0";

declare namespace array = "http://www.w3.org/2005/xpath-functions/array";

(: The URI of the document that is to be queried :)
declare variable $document-uri as xs:string := "books.json";

(: The JSON document :)
declare variable $document := json-doc($document-uri);

(: The technology ID :)
declare variable $technology as xs:string := "XSL";

(: The books :)
let $books := $document?books?book

(: Lists the technology's books:)
for $i in (1 to array:size($books))
    let $book := $books($i)
    where (exists($book?technology) and (compare($book?technology, $technology) eq 0))
    return
        <book
            id="{$book?anchor}">
            <title>{$book?title}</title>
            <author>{$book?author}</author>
        </book>